﻿const urls=[
	"https://api.guancha.cn/Appdata/NewsList/?isline=0&size=20&page=0&id=homepage&type=1&newstype=1",
	"https://api.guancha.cn/Appdata/NewsList/?isline=0&size=20&page=0&id=homepage&type=1&newstype=2",
	"https://api.guancha.cn/Appdata/NewsList/?isline=0&size=20&page=0&id=homepage&type=1&newstype=3",
	"https://api.guancha.cn/Appdata/NewsList/?isline=0&size=20&page=0&id=GuanWangKanPian&type=0&newstype=1",
	"https://c.m.163.com/nc/article/headline/T1348647909107/0-20.html",
	"https://c.m.163.com/nc/article/list/T1350383429665/0-20.html"];
const ids = ['','','','','T1348647909107','T1350383429665'];
var saveurls = [];
var showobj = [];
var first = false;

chrome.browserAction.onClicked.addListener(function(tab) {	
	getMsg();
});

getMsg();
setInterval(function(){
	getMsg();
	},1800*1000);//半小时检测一次

function getMsg(){
	
	showobj = [];
	var news = [] ;
	for( var i =0; i< urls.length;i++){
		url = urls[i];
		getAjax(url,
				function(data){					
					var res = JSON.parse(data);	
					var datas = [];				
					if (url.indexOf("guancha")!=-1){
						datas = parseGcNews(res.datas);
					} else{	
						datas = parseNetNews(res[ids[i]]);						
					};
					news.push(...datas);															
				},
				function(){
					console.log('Error: getMsg()');
				}
		);		
	}
	for (var i=0;i<news.length;i++){
		var newt = news[i];
		if (newt && newt.shareurl && saveurls.indexOf(newt.shareurl)==-1){
			saveurls.push(newt.shareurl);															
			if (first){
				showobj.push(newt);					
			}
		}
	}
	if (!first){
		first = true;
		new Notification("新闻初始化成功",{		                     
				body:""
			})
	}else{
		if (showobj.length>0){			
			new Notification(showobj.length+"条新的新闻",{		                     
				body:""
			})
			Show(showobj);
		}else{
			new Notification("暂时没有新的新闻",{		                     
				body:""
			})
		}
	}
	
};
function parseNetNews(newsList){
  return newsList.map(function(news){
    var { docid: id, title, mtime: date,digest:summary,imgsrc:icons,url:shareurl} = news;
      return { id, title, date, summary,icons,shareurl};
  })
};

function parseGcNews(newsList){
  return newsList.map(function(news){
      var { id,title,news_time:date,summary,pic_l:icons,mobile_url:shareurl} = news;  
      shareurl = "http://www.guancha.cn"+ shareurl;
        return {id, title, date, summary,icons,shareurl};
  })
};

//Ajax
function getAjax(url,callback,error,async){
		var xhr = new XMLHttpRequest();
		xhr.onreadystatechange = function (data) {
			if (xhr.readyState == 4) {
				if (xhr.status == 200) {
					var data = xhr.responseText;
					callback(data);
				} else {
					//alert('ajax error');
					error();
				}
			}
		}		
		xhr.open("GET", url, async);//默认同步
		xhr.send();
};

//提示框
function Show(showobj){	
	for (var i=0;i<10;i++){
		newt = showobj[i];
		creatNotifaction(newt);
	}
};

function creatNotifaction(newt){
	var nat = new Notification(newt.title,{		                     
			body:newt.date+"\n"+newt.summary
		})
	nat.onclick=function(){
		chrome.tabs.create({
			url:newt.shareurl
		});
		nat.close();
	};
}